function Player::killIfVisitor(%this,%client){
	if(!%client)
		return;
	if(!%client.isAdmin){
		messageClient(%this.client,'',"You must be an admin in order to enter this area");
		%this.InstantRespawn();
	}
}
RTB_registerPref("Current Event","Party Place","$Party::Event","string 200 200","Gamemode_PartyPlace","none",0,0);
registerOutputEvent("Player","killIfVisitor","",1);
function Party_Init(){ //ASSIGN VARIABLES FOR PARTY PLACE HERE
	$Party::Timer[0]=0;
	$Party::Timer[1]=0;
	$Party::Timer[2]=0;
	$Party::Timer[3]=0;
	$Party::Timer[4]=0;
	$Party::Timer[5]=0;
	$Party::Timer[6]=0;
	$Party::Timer[7]=0;
	$Party::Minigame=$DefaultMiniGame;
	$Party::Timer::Running=0;
	$Party::Timer::LastClock="00:00:00";
	$Party::Timer::Celebrating=false;
	$Party::Event="none";
	//CANCEL ALL SCHEDULES HERE
	cancel($Party::TickSchedule);
	cancel($Party::UpdateSchedule);
}
function Party_WelcomeMsg(){
	if(!isObject(_clockControl)) //is a brick from the save loaded?
		schedule(1000,0,Party_WelcomeMsg);
	else
	{
		$Server::WelcomeMessage="<color:00ff00>Welcome to the Party Place, %1.";
		$Party::Minigame=$DefaultMiniGame;
		Party_Tick();
	}
}
Party_WelcomeMsg();
Party_Init();
package PartyPlace{
	function destroyServer(){
		Parent::destroyServer();
		//hide all evidence that the variables were even assigned/change all $Party variables to a nothing string
		$Party::Timer[0]= "";
		$Party::Timer[1]= "";
		$Party::Timer[2]= "";
		$Party::Timer[3]= "";
		$Party::Timer[4]= "";
		$Party::Timer[5]= "";
		$Party::Timer[6]= "";
		$Party::Timer[7]= "";
		$Party::Timer::Running="";
		$Party::Timer = "";
		$Party::Minigame="";
		cancel($Party::TickSchedule);
		cancel($Party::UpdateSchedule);
		$Party::TickSchedule = "";
		$Party::UpdateSchedule = "";
		$Party::Timer::Celebrating="";
	}
};
deactivatepackage(PartyPlace);
activatepackage(PartyPlace);
function Party_Tick(){
	//PUT TICK STUFF HERE
	%mg=$Party::Minigame;
	%thing="\c4";
	if($Party::Timer::Celebrating)
		%thing="\c0";
	%mg.bottomPrintAll("<just:center>\c7The current time is " @ getDate() SPC getTime() @ ". <br>\c7Countdown clock time: " @ %thing @ $Party::Timer[7] @ $Party::Timer[6] @ ":" @ $Party::Timer[5] @ $Party::Timer[4] @ ":" @ $Party::Timer[3] @ $Party::Timer[2] @ ":" @ $Party::Timer[1] @ $Party::Timer[0],1,1);
	$Party::TickSchedule=schedule(10,0,Party_Tick);
}
function serverCmdToggleCountdown(%client){
	if(!%client.isAdmin){
		messageClient(%client,'',"Only admins may toggle the countdown clock");
		return;
	}
	$Party::Timer::Running=!$Party::Timer::Running;
	%thing="off";
	if($Party::Timer::Running)
		%thing="on";
	messageAll('MsgAdminForce',"\c3"@ %client.name SPC "\c2turned \c3" @ %thing @ " \c2the countdown clock.");
	Party_Update();
}
function GameConnection::partyPlaceEvent(%this){
	%this.centerPrint("<color:00ff00>The current event is: " @ $Party::Event @ ".",5);
}
registerOutputEvent("GameConnection","partyPlaceEvent","",1);
function serverCmdFrontDoors(%client,%enabled){
	if(!%client.isAdmin){
		messageClient(%client,'',"You must be an admin in order to use this command.");
		return;
	}
	if(%enabled$="open"){
		messageAll('MsgAdminForce',"\c3"@%client.name@ "\c2 opened the front doors.");
		_front_door_open.fireRelay();
	}
	else if(%enabled$="close" || !%enabled){
		messageAll('MsgAdminForce',"\c3"@%client.name@ "\c2 closed the front doors.");
		_front_door_close.fireRelay();
	}
}
	
function serverCmdSetCountdown(%client,%d10,%d1,%h10,%h1,%m10,%m1,%s10,%s1,%startAfterEnter){
	if(!%client.isAdmin){
		messageClient(%client,'',"Only admins may set the countdown time");
		return;
	}
	if($Party::Timer::Running){
		messageClient(%client,'',"The timer must be stopped in order to use this command. Use /togglecountdown to turn it off.");
		return;
	}
	$Party::Timer[7]=%d10;
	$Party::Timer[6]=%d1;
	$Party::Timer[5]=%h10;
	$Party::Timer[4]=%h1;
	$Party::Timer[3]=%m10;
	$Party::Timer[2]=%m1;
	$Party::Timer[1]=%s10;
	$Party::Timer[0]=%s1;
	%a=".";
	if(%startAfterEnter && $Party::Timer::Running==0){
		%a=" \c2and started the clock.";
		$Party::Timer::Running=1;
	}
	Party_Update();
	messageAll('MsgAdminForce',"\c3"@ %client.name SPC "\c2has set the countdown time to \c3" @ $Party::Timer[7] @ $Party::Timer[6] @ ":" @ $Party::Timer[5] @ $Party::Timer[4] @ ":" @ $Party::Timer[3] @ $Party::Timer[2] @ ":" @ $Party::Timer[1] @ $Party::Timer[0] @ %a);
}
function serverCmdStopCelebration(%client){
	if(!%client.isAdmin){
		messageClient(%client,'',"You must be admin to use that command");
		return;
	}
	messageClient(%client,'',"\c2You stopped the celebration.");
	$Party::Timer::Celebrating=false;
	_t_r_fun_stop.fireRelay();
}
function Party_Update(){
	_clockControl.fireRelay();
	if(!$Party::Timer::Running)
		return;
	$Party::Timer[0]--;
	if($Party::Timer[0]<0){//sec1
		$Party::Timer[0]=9;
		$Party::Timer[1]--;
	}
	if($Party::Timer[1]<0){//sec10
		$Party::Timer[1]=5;
		$Party::Timer[2]--;
	}
	if($Party::Timer[2]<0){//min1
		$Party::Timer[2]=9;
		$Party::Timer[3]--;
	}
	if($Party::Timer[3]<0){//min10
		$Party::Timer[3]=5;
		$Party::Timer[4]--;
	}
	if($Party::Timer[4]<0){//hr1
		$Party::Timer[4]=9;
		$Party::Timer[5]--;
	}
	if($Party::Timer[5]<0){//hr10
		$Party::Timer[4]=4;
		$Party::Timer[5]=2;
		$Party::Timer[6]--;
	}
	if($Party::Timer[6]<0){
		$Party::Timer[6]=9;
		$Party::Timer[7]--;
	}
	%allIsZero=true;
	for(%i=0;%i<8;%i++){
		if($Party::Timer[%i]!=0)
			%allIsZero=false;
	}
	if(%allIsZero){
		$Party::Timer::Celebrating=true;
		$Party::Timer::Running=0;
		_timerEndRelay.fireRelay();
		$Party::Timer[0]=0;
		$Party::Timer[1]=0;
		$Party::Timer[2]=0;
		$Party::Timer[3]=0;
		$Party::Timer[4]=0;
		$Party::Timer[5]=0;
		$Party::Timer[6]=0;
		$Party::Timer[7]=0;
	}
	$Party::UpdateSchedule=schedule(1000,0,Party_Update);
}
function fxDTSBrick::updateTimer(%this,%var){
	%this.setPrintCount($Party::Timer[%var]);
}
registerOutputEvent("fxDTSBrick","updateTimer","int 0 7");
